﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms; 
using System.Runtime.InteropServices;

namespace MUR500_Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        int st = 0;
        [DllImport("MUR500USB.dll",EntryPoint="TX2_Init")]
        public static extern int TX2_Init();

        [DllImport("MUR500USB.dll", EntryPoint = "TX2_Request")]
        public static extern int TX2_Request(UInt16 mode, ref UInt16 tagType);

        [DllImport("MUR500USB.dll", EntryPoint = "TX2_Casc_Anticoll")]
        public static extern int TX2_Casc_Anticoll(UInt16 bcnt,UInt16 code, ref UInt32 snr);

        [DllImport("MUR500USB.dll", EntryPoint = "TX2_Casc_Select")]
        public static extern int TX2_Casc_Select(UInt16 code, UInt32 snr, ref UInt16 sak);

        [DllImport("MUR500USB.dll", EntryPoint = "TX2_Auth_Key")]
        public static extern int TX2_Auth_Key(UInt16 mode, string key, UInt16 secnr);

        [DllImport("MUR500USB.dll", EntryPoint = "TX2_Write_Enc")]
        public static extern int TX2_Write_Enc(UInt16 addr, string data);

        [DllImport("MUR500USB.dll", EntryPoint = "TX2_Read_Enc")]
        public static extern int TX2_Read_Enc(UInt16 addr, StringBuilder data);

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        //连接
        private void btnCon_Click(object sender, EventArgs e)
        {
            st = TX2_Init();
            if (st != 0)
            {
                MessageBox.Show("连接不成功，错误代码：" + st.ToString());
            }
             
        }
        //写数据
        private void btnWriteData_Click(object sender, EventArgs e)
        {
            if(ISCard())
            {
                if(txtWriteData.Text!="")
                {
                    st = TX2_Write_Enc(20, txtWriteData.Text);//20为写入块号，txtwritedata.text为写入值
                    if (st != 0)
                    {
                        MessageBox.Show("写入数据失败，错误代码：" + st.ToString());
                         
                    }

                }
            }
        }
        //读数据
        private void btnReadData_Click(object sender, EventArgs e)
        {
            if (ISCard())
            {
                StringBuilder strData = new StringBuilder();
               // st = TX2_Read_Enc(20, strData); //20为块号,strdata为输出值
                st=TX2_ReadCard(20,ref strData);
                if (st != 0)
                {
                    MessageBox.Show("读数据失败，错误代码：" + st.ToString()); 
                }
                else
                {
                    ListInfo.Items.Add(strData.ToString());
                }
            }
        }
        //卡片验证方法
        private bool ISCard()
        {
            bool isTrue = true;
            UInt16 tagType=0;
            UInt32 snr = 0;
            UInt16 sak = 0;

            st = TX2_Request(0, ref tagType);//进行请求，以密钥A模式进行验证如果用密码B验证，mode为4；0为验证模式，tagtype为输出卡片类型
            if(st!=0)
            {
                st = TX2_Request(0, ref tagType);//如果第一次请求失败，再重复请求一次
                if(st!=0)
                {
                    MessageBox.Show("请求失败，错误代码：" + st.ToString());
                    return false;
                }
            }

            st = TX2_Casc_Anticoll(0, 0x93, ref snr); //可选级数的防碰撞操作; 
            //0为预选卡已经知道的序列号的的位数，通常都设置为0，0x93为防碰撞层级， 一层-0x93；二层-0x95；三层-0x97
            //输出 snr为 卡的序列号
            if (st != 0)
            {
                MessageBox.Show("防碰撞失败，错误代码：" + st.ToString());
                return false;
            }

            st = TX2_Casc_Select(0x93, snr, ref sak);//选择某一个序列号的卡
            //0x93为防碰撞层级,snr为 卡的序列号
            //输出 sak 为 是否选择成功的应答
            if (st != 0)
            {
                MessageBox.Show("选择卡失败，错误代码：" + st.ToString());
                return false;
            }

            st = TX2_Auth_Key(0, "ffffffffffff", 5);//验证第5扇区,将密钥传送到MUR内对卡片进行验证
            //0 密钥类型
            //ffffffffffff 用于证实的密码（这个是初始密码）
            //5 所要验证卡的扇区号取值
            if (st != 0)
            {
                MessageBox.Show("验证失败，错误代码：" + st.ToString());
                return false;
            }
            return isTrue;
        }

        public  int TX2_ReadCard(UInt16 addrNum, ref StringBuilder strData)
        { 
            if (ISCard())
            {
                StringBuilder strReadData = new StringBuilder();
                if (addrNum > 0)
                {
                    st = TX2_Read_Enc(addrNum, strReadData); 
                }

            }
            return st;
        }

    }
}
